//---------------------------------------------------------------------------

#ifndef ControlQueueH
#define ControlQueueH
//---------------------------------------------------------------------------

#include "common/singleton.h"
#include <System.hpp>

class Command;

class ControlQueue: public CSingleton<ControlQueue>
{
private:
	ControlQueue();
	friend CSingleton<ControlQueue>;
public:
	int GetCommand(Command& cmd);

	void Call(int accountId, AnsiString target);
	void Answer(int callId, AnsiString audioRxMod="", AnsiString audioRxDev="");
	void Transfer(int callId, AnsiString target);
	void SendDigit(int callId, char key);
	void Hold(int callId, bool state);
	void Mute(int callId, bool state);
	void Hangup(int callId, int code=0);
	void SetMsgLogging(bool enabled);
	void ReRegister(int accountId);
	void UnRegister(int accountId);
	void StartRing(AnsiString wavFile);
	void StopRing(void);
	void Record(AnsiString wavFile, unsigned int channels);
	/** \brief Start transmitting RTP to specified targee
		\param target address IP + port
		\param pagingTxWaveFile audio file to be transmitted; if not specified default audio source is used
	*/
	void PagingTx(AnsiString target, AnsiString pagingTxWaveFile, AnsiString codec, unsigned int ptime);
};

#define UA ControlQueue::Instance()

#endif
